% Summary plots of the detector simulations
% using data created by run_detsim.m
% This assumes that the files created by run_detsim.m are
% in a subdirectory 'matfiles/'
%
% variables to set externally:
%  loaddet:   1  loads data
%	      0  doesn't load data
%  doplot: a six element vector that indicates which plots to do
%	   e.g. doplot = [1 0 1 0 0 0] does the 1st and 3rd plots.
%
% Uses: plotroc, no_blanks


	roctype = [];
	direcname = 'matfiles/';
       if loaddet


	 detwidthvec = [100 50 25];
         suffixes  = ['c2c2';
		      'gg  ';
		      'ee  ';
		      'gc2 ';
		      'ec2 ';
		      'g2g ';
		      'e2e ';];




	numsuffix = size(suffixes,1);
	 dvec = [4 5];
	 gamma = 1;
         kminmax = [4 8;4 8; 6 8; 7 7; 7 7; 6 7;7 7;];

                     

        for i = 1:numsuffix
	  suffix = no_blanks(suffixes(i,:));

	  for d = dvec;
              for k = kminmax(i,1):kminmax(i,2)

                filename = sprintf('%sds3bk%dg%dd%d%s',direcname,k,gamma,d,suffix);
		eval(['load ',filename]);

                for detwidth = detwidthvec
                 label0 = sprintf('k%dd%dw%d%s',k,d,detwidth,suffix);
                 label1 = sprintf('k%dd%d%s',k,d,suffix);
		 eval(sprintf('ds%s = det_stat%d;',label0,detwidth));
		 eval(sprintf('es%s = est_scale%d;',label0,detwidth));
		 eval(sprintf('ed%s = est_delay%d;',label0,detwidth));
                 eval(sprintf('ns%s = numsearch;',label1));
                 eval(sprintf('ns2%s = numsearch2;',label1));
	         eval(sprintf('nh%s = numhits;',label1));
                 eval(sprintf('nm%s = nmaxatktrack1;',label1));
                end
              end
           end
          end

	end





	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	% Look at performance for different input scales
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

	if doplot(1);
	 %Summary: 

        
	 suffixes = ['c2c2';
		     'gg  ';
		     'ee  ';];
	
         
	 for m = 1
	  for usedw = usedwmat
	  suffix = usesuffix;
	  %suffix = no_blanks(suffixes(m,:));

	  span0 = [1:2];span1 = span0;
	  %baseline plot to show that all matched filtering
          % operations are same across scales
	  % note these are insensitive to scale.
	  subplot(2,2,1)
	  eval(sprintf('plotroc([dsk7d5w50%s(:,span0) dsk6d5w50%s(:,span0),dsk8d5w50%s(:,span0) ],roctype);',suffix,suffix,suffix));
          hold on;

	  eval(sprintf('plotroc([dsk7d4w50%s(:,span0) dsk6d4w50%s(:,span1) ,dsk8d4w50%s(:,span1) ],roctype);',suffix,suffix,suffix));
          hold off;
     


          for l = 1:3;
	
            k = l+5;

	    subplot(2,2,l+1)


	  span0 = usespan;
          span1 = span0;
	  eval(sprintf('plotroc([dsk%dd5w%d%s(:,span0) ],[]);',k,usedw,suffix));
	  title(sprintf('usek %d, %s',k,suffix));
      
          hold on;
	  eval(sprintf('plotroc([dsk%dd4w%d%s(:,span0) ],[]);',k,usedw,suffix));

          hold off;

	end
	plotname = sprintf('dw%d%s.ps',usedw,suffix)

        timelabel(sprintf('%s,usespan: %s',plotname,j2str(span0)),-.7,-.2)
	orient portrait;
%	eval(['print -dps ',plotname]);

        end
       end
      end

      if doplot(2)
	usek = 7;
	usedw = 25;
	span0 = [1:2];
	span = [1:2 7:8];
	suffixes = ['gc2';
		    'ec2';
		    'g2g';
		    'e2e';];
	
	suffixes0 = ['c2c2';
		     'c2c2';
		     'gg  ';
		     'ee  '];

	matchlabels = ['C_{2} ';
		       'C_{2} ';
		       'g(t)  ';
		       'e(t)  ';];
	siglabels = ['g(t)    ';
		     'e(t)    ';
		     'g_{s}(t)';
		     'e_{s}(t)';];


	for l = 1:4

	matchlab = no_blanks(matchlabels(l,:));
        siglab = no_blanks(siglabels(l,:));

	l1 = sprintf('%s matched by %s; A',matchlab,matchlab);
	l2 = sprintf('%s matched by %s; A',siglab,matchlab);
	l3 = sprintf('%s matched by %s; C',siglab,matchlab);
	lmat = str2mat(l1,l2,l3);
	if l < 3
	 tstr = sprintf('(%s) ROC for signal model mismatch: %s and %s',setstr(96+l),siglab,matchlab);
        else
	 tstr = sprintf('(%s) ROC for signal scale mismatch: %s and %s',setstr(96+l),siglab,matchlab);
	end

	subplot(2,2,l) 
	suffix = suffixes(l,:);
	suffix0 = no_blanks(suffixes0(l,:));
	eval(sprintf('h = plotroc([dsk%dd5w%d%s(:,span0) dsk%dd5w%d%s(:,span)],[])',usek,usedw,suffix0,usek,usedw,suffix));
	hl = legend(h,lmat,4);
	set(hl,'visible','off');
	title(tstr);
	hold on

	eval(sprintf('plotroc([dsk%dd4w%d%s(:,span0) dsk%dd4w%d%s(:,span)],[])',usek,usedw,suffix0,usek,usedw,suffix));

        hold off;
 	end



	orient portrait;


      end


	if doplot(3)

	 subplot(1,2,1);
	 h =  plotroc([dsk6d5w25gg(:,1:2) dsk6d5w25g2g(:,1:2) dsk5d5w25gg(:,1:2) dsk4d5w25gg(:,1:2)],[]);
	lstr = ['k = 6  ';
		'k = 5.5';
		'k = 5  ';
		'k = 4  ';];
	        
		
	        
	hl = legend(h,lstr,4);
	set(hl,'visible','off');
	title('(a) ROC: scale discrimination for g(t) and g_{s}(t)');
	axis('square');
	
	b = get(hl,'Children');
	for m = 1:2:8;
	xd = get(b(m),'XData');
	set(b(m),'XData',[xd(1) .38]);
        end

	subplot(1,2,2)
	 h = plotroc([dsk6d5w25c2c2(:,1:2) dsk5d5w25c2c2(:,1:2) dsk4d5w25c2c2(:,1:2)],[]);

	lstr = ['k = 6';
		'k = 5';
		'k = 4';];
	hl2 = legend(h,lstr,4);
	set(hl2,'visible','off');
	b = get(hl2,'Children');
	for m = 1:2:6;
	xd = get(b(m),'XData');
	set(b(m),'XData',[xd(1) .38]);
        end
         
	title('(b) ROC: scale discrimination for C_{2}');
	axis('square');




	orient portrait;
	end


	if doplot(4)
	  suffixes = ['c2c2';
		      'gg  ';
		      'ee  ';];
	  titles = ['C_{2}      ';
		    'Gaussian   ';
		    'Exponential';];
	  labels  = ['A';'B';'C';'D'];
	
	  usedw = 25;
	  span0 = [1:2 3:4 7:8 11:12];
	  numsuffixes = size(suffixes,1);
	  plotnum = 0;
          for l = 1:numsuffixes
	   suffix = no_blanks(suffixes(l,:));
	   thistitle = no_blanks(titles(l,:));
	   for k = [6:8]
             plotnum = plotnum + 1;
	     subplot(3,3,plotnum);

	     eval(sprintf('h = plotroc([dsk%dd5w%d%s(:,span0) ],[]);',k,usedw,suffix));
	     title(sprintf('(%s) %s, k = %d',setstr(96+plotnum),thistitle,k));
	     %legend(h,labels,4);
      
             hold on;
	     eval(sprintf('plotroc([dsk%dd4w%d%s(:,span0) ],[]);',k,usedw,suffix));

	  end
	 end
	orient tall;

	end


	if doplot(5)
	  suffixes = ['c2c2';];

	  titles = ['C_{2}      ';
		    'Gaussian   ';
		    'Exponential';];
	  labels  = ['A';'B';'C'];
	
	  usedw = 25;
	  span0 = [1:2 3:4 7:8 ];
	  numsuffixes = size(suffixes,1);
	  plotnum = 0;
          for l = 1:numsuffixes
	   suffix = no_blanks(suffixes(l,:));
	   thistitle = no_blanks(titles(l,:));
	   for k = [6:8]
             plotnum = plotnum + 1;
	     subplot(1,3,plotnum);

	     eval(sprintf('h = plotroc([dsk%dd5w%d%s(:,span0) ],[]);',k,usedw,suffix));
	     title(sprintf('(%s) %s, k = %d',setstr(96+plotnum),thistitle,k));
	     %legend(h,labels,4);
      
             hold on;
	     eval(sprintf('plotroc([dsk%dd4w%d%s(:,span0) ],[]);',k,usedw,suffix));


	  end
	 end
	orient portrait;

	end







      if doplot(6)
	usek = 7;
	usedw = 25;
	span0 = [1:2];
	span = [1:2 7:8];
	suffixes = ['ec2';
		    'e2e';];
	
	suffixes0 = ['c2c2';
		     'ee  '];

	matchlabels = ['C_{2} ';
		       'e(t)  ';];
	siglabels = ['e(t)    ';
		     'e_{s}(t)';];


	for l = 1:2

	matchlab = no_blanks(matchlabels(l,:));
        siglab = no_blanks(siglabels(l,:));

	l1 = sprintf('%s matched by %s; A',matchlab,matchlab);
	l2 = sprintf('%s matched by %s; A',siglab,matchlab);
	l3 = sprintf('%s matched by %s; C',siglab,matchlab);
	lmat = str2mat(l1,l2,l3);
	 tstr = sprintf('(%s) Signal model mismatch: %s and %s',setstr(96+l),siglab,matchlab);


	subplot(2,2,l) 
	suffix = suffixes(l,:);
	suffix0 = no_blanks(suffixes0(l,:));
	eval(sprintf('h = plotroc([dsk%dd5w%d%s(:,span0) dsk%dd5w%d%s(:,span)],[])',usek,usedw,suffix0,usek,usedw,suffix));
	legend(h,lmat,4);
	set(legend,'visible','off');
	title(tstr);
	hold on

	eval(sprintf('plotroc([dsk%dd4w%d%s(:,span0) dsk%dd4w%d%s(:,span)],[])',usek,usedw,suffix0,usek,usedw,suffix));

        hold off;
 	end




	 subplot(2,2,3);
	 h =  plotroc([dsk6d5w25gg(:,1:2) dsk6d5w25g2g(:,1:2) dsk5d5w25gg(:,1:2) dsk4d5w25gg(:,1:2)],[]);
	lstr = ['k = 6  ';
		'k = 5.5';
		'k = 5  ';
		'k = 4  ';];
	        
		
	        
	hl = legend(h,lstr,4);
	title('(c) Scale discrimination for g(t) and g_{s}(t)');

	set(hl,'visible','off');	
	b = get(hl,'Children');
	for m = 1:2:8;
	xd = get(b(m),'XData');
	set(b(m),'XData',[xd(1) .38]);
        end

	subplot(2,2,4)
	 h = plotroc([dsk6d5w25c2c2(:,1:2) dsk5d5w25c2c2(:,1:2) dsk4d5w25c2c2(:,1:2)],[]);

	lstr = ['k = 6';
		'k = 5';
		'k = 4';];
	hl2 = legend(h,lstr,4);
	b = get(hl2,'Children');
	for m = 1:2:6;
	xd = get(b(m),'XData');
	set(b(m),'XData',[xd(1) .38]);
        end
        set(hl2,'visible','off'); 
	title('(d) Scale discrimination for C_{2}');





	orient portrait;
	end